Index: palm/trunk/SOURCE/cpu_statistics.f90
===================================================================
--- palm/trunk/SOURCE/cpu_statistics.f90	(revision 1)
+++ palm/trunk/SOURCE/cpu_statistics.f90	(revision 1)
@@ -0,0 +1,286 @@
+ SUBROUTINE cpu_statistics
+
+!-------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: cpu_statistics.f90,v $
+! Revision 1.13  2006/04/26 12:10:51  raasch
+! Output of number of threads per task, max = min in case of 1 PE
+!
+! Revision 1.12  2003/03/16 09:30:22  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.11  2002/12/19 14:12:08  raasch
+! PE results are collected on PE0 in order to calculate mean cpu statistics.
+! Output format changed.
+!
+! Revision 1.10  2001/03/30 07:01:02  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.9  2001/01/22 05:49:49  raasch
+! Module test_variables removed
+!
+! Revision 1.8  2001/01/02 17:25:23  raasch
+! Unit 18 closed at the end of the subroutine
+!
+! Revision 1.7  2000/12/20 10:10:26  letzel
+! All comments translated into English.
+!
+! Revision 1.1  1997/07/24 11:11:11  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Analysis and output of the cpu-times measured. All PE results are collected
+! on PE0 in order to calculate the mean cpu-time over all PEs and other
+! statistics. The output is sorted according to the amount of cpu-time consumed
+! and output on PE0.
+!-------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE pegrid
+    USE control_parameters
+
+    IMPLICIT NONE
+
+    INTEGER    ::  i, ii(1), iii, lp, sender
+    REAL, SAVE ::  norm = 1.0
+    REAL, DIMENSION(:),   ALLOCATABLE ::  pe_max, pe_min, pe_rms, sum
+    REAL, DIMENSION(:,:), ALLOCATABLE ::  pe_log_points
+
+
+!#if defined( __hpmuk )  &&  ! defined( __chinook )
+!    norm = clock_ticks_per_second()
+!#endif
+
+!
+!-- Compute cpu-times in seconds
+    log_point%mtime  = log_point%mtime  / norm
+    log_point%sum    = log_point%sum    / norm
+    log_point%vector = log_point%vector / norm
+    WHERE ( log_point%counts /= 0 )
+       log_point%mean = log_point%sum / log_point%counts
+    END WHERE
+
+
+!
+!-- Collect cpu-times from all PEs and calculate statistics
+    IF ( myid == 0 )  THEN
+!
+!--    Allocate and initialize temporary arrays needed for statistics
+       ALLOCATE( pe_max( SIZE( log_point ) ), pe_min( SIZE( log_point ) ), &
+                 pe_rms( SIZE( log_point ) ),                              &
+                 pe_log_points( SIZE( log_point ), 0:numprocs-1 ) )
+       pe_min = log_point%sum
+       pe_max = log_point%sum    ! need to be set in case of 1 PE
+       pe_rms = 0.0
+
+#if defined( __parallel )
+!
+!--    Receive data from all PEs
+       DO  i = 1, numprocs-1
+          CALL MPI_RECV( pe_max(1), SIZE( log_point ), MPI_REAL, &
+                         MPI_ANY_SOURCE, MPI_ANY_TAG, comm2d, status, ierr )
+          sender = status(MPI_SOURCE)
+          pe_log_points(:,sender) = pe_max
+       ENDDO
+       pe_log_points(:,0) = log_point%sum   ! Results from PE0
+!
+!--    Calculate mean of all PEs, store it on log_point%sum
+!--    and find minimum and maximum
+       DO  iii = 1, SIZE( log_point )
+          DO  i = 1, numprocs-1
+             log_point(iii)%sum = log_point(iii)%sum + pe_log_points(iii,i)
+             pe_min(iii) = MIN( pe_min(iii), pe_log_points(iii,i) )
+             pe_max(iii) = MAX( pe_max(iii), pe_log_points(iii,i) )
+          ENDDO
+          log_point(iii)%sum = log_point(iii)%sum / numprocs
+!
+!--       Calculate rms
+          DO  i = 0, numprocs-1
+!             IF ( log_point(iii)%place == 'run_control' )  THEN
+!                PRINT*, 'pe_rms=',pe_rms(iii),' plp=',pe_log_points(iii,i), &
+!                        ' lps=',log_point(iii)%sum
+!             ENDIF
+             pe_rms(iii) = pe_rms(iii) + ( &
+                                 pe_log_points(iii,i) - log_point(iii)%sum &
+                                         )**2
+          ENDDO
+          pe_rms(iii) = SQRT( pe_rms(iii) / numprocs )
+       ENDDO
+    ELSE
+!
+!--    Send data to PE0 (pe_max is used as temporary storage to send
+!--    the data in order to avoid sending the data type log)
+       ALLOCATE( pe_max( SIZE( log_point ) ) )
+       pe_max = log_point%sum
+       CALL MPI_SEND( pe_max(1), SIZE( log_point ), MPI_REAL, 0, 0, comm2d, &
+                      ierr )
+#endif
+
+    ENDIF
+
+!
+!-- Write cpu-times
+    IF ( myid == 0 )  THEN
+!
+!--    Re-store sums
+       ALLOCATE( sum( SIZE( log_point ) ) )
+       WHERE ( log_point%counts /= 0 )
+          sum = log_point%sum
+       ELSEWHERE
+          sum = -1.0
+       ENDWHERE
+
+!
+!--    Write cpu-times sorted by size
+       CALL check_open( 18 )
+       WRITE ( 18, 100 )  TRIM( run_description_header ),        &
+                          numprocs * threads_per_task, numprocs, &
+                          threads_per_task
+       DO
+          ii = MAXLOC( sum )
+          i = ii(1)
+          IF ( sum(i) /= -1.0 )  THEN
+             WRITE ( 18, 102 ) &
+	        log_point(i)%place, log_point(i)%sum,                &
+                log_point(i)%sum / log_point(1)%sum * 100.0,         &
+                log_point(i)%counts, pe_min(i), pe_max(i), pe_rms(i)
+             sum(i) = -1.0
+          ELSE
+             EXIT 
+          ENDIF
+       ENDDO
+    ENDIF
+
+
+!
+!-- The same procedure again for the individual measurements.
+!
+!-- Compute cpu-times in seconds
+    log_point_s%mtime  = log_point_s%mtime  / norm
+    log_point_s%sum    = log_point_s%sum    / norm
+    log_point_s%vector = log_point_s%vector / norm
+    WHERE ( log_point_s%counts /= 0 )
+       log_point_s%mean = log_point_s%sum / log_point_s%counts
+    END WHERE
+
+!
+!-- Collect cpu-times from all PEs and calculate statistics
+#if defined( __parallel )
+!
+!-- Set barrier in order to avoid that PE0 receives log_point_s-data
+!-- while still busy with receiving log_point-data (see above)
+    CALL MPI_BARRIER( comm2d, ierr )    
+#endif
+    IF ( myid == 0 )  THEN
+!
+!--    Initialize temporary arrays needed for statistics
+       pe_min = log_point_s%sum
+       pe_max = log_point_s%sum    ! need to be set in case of 1 PE
+       pe_rms = 0.0
+
+#if defined( __parallel )
+!
+!--    Receive data from all PEs
+       DO  i = 1, numprocs-1
+          CALL MPI_RECV( pe_max(1), SIZE( log_point ), MPI_REAL, &
+                         MPI_ANY_SOURCE, MPI_ANY_TAG, comm2d, status, ierr )
+          sender = status(MPI_SOURCE)
+          pe_log_points(:,sender) = pe_max
+       ENDDO
+       pe_log_points(:,0) = log_point_s%sum   ! Results from PE0
+!
+!--    Calculate mean of all PEs, store it on log_point_s%sum
+!--    and find minimum and maximum
+       DO  iii = 1, SIZE( log_point )
+          DO  i = 1, numprocs-1
+             log_point_s(iii)%sum = log_point_s(iii)%sum + pe_log_points(iii,i)
+             pe_min(iii) = MIN( pe_min(iii), pe_log_points(iii,i) )
+             pe_max(iii) = MAX( pe_max(iii), pe_log_points(iii,i) )
+          ENDDO
+          log_point_s(iii)%sum = log_point_s(iii)%sum / numprocs
+!
+!--       Calculate rms
+          DO  i = 0, numprocs-1
+             pe_rms(iii) = pe_rms(iii) + ( &
+                                 pe_log_points(iii,i) - log_point_s(iii)%sum &
+                                         )**2
+          ENDDO
+          pe_rms(iii) = SQRT( pe_rms(iii) / numprocs )
+       ENDDO
+    ELSE
+!
+!--    Send data to PE0 (pe_max is used as temporary storage to send
+!--    the data in order to avoid sending the data type log)
+       pe_max = log_point_s%sum
+       CALL MPI_SEND( pe_max(1), SIZE( log_point ), MPI_REAL, 0, 0, comm2d, &
+                      ierr )
+#endif
+
+    ENDIF
+
+!
+!-- Write cpu-times
+    IF ( myid == 0 )  THEN
+!
+!--    Re-store sums
+       WHERE ( log_point_s%counts /= 0 )
+          sum = log_point_s%sum
+       ELSEWHERE
+          sum = -1.0
+       ENDWHERE
+
+!
+!--    Write cpu-times sorted by size
+       WRITE ( 18, 101 )
+       DO
+          ii = MAXLOC( sum )
+          i = ii(1)
+          IF ( sum(i) /= -1.0 )  THEN
+             WRITE ( 18, 102 ) &
+                log_point_s(i)%place, log_point_s(i)%sum, &
+                log_point_s(i)%sum / log_point(1)%sum * 100.0, &
+                log_point_s(i)%counts, pe_min(i), pe_max(i), pe_rms(i)
+             sum(i) = -1.0
+          ELSE
+             EXIT 
+          ENDIF
+       ENDDO
+
+!
+!--    Empty lines in order to create a gap to the results of the model 
+!--    continuation runs
+       WRITE ( 18, 103 )
+
+!
+!--    Unit 18 is not needed anymore
+       CALL close_file( 18 )
+
+    ENDIF
+
+
+100 FORMAT (A/11('-')//'CPU measures for ',I3,' PEs (',I3,' tasks *',I3,    &
+            &' threads):'/ &
+             &'--------------------------------------------------'//        &
+            &'place:                        mean        counts      min  ', &
+             &'     max       rms'/ &
+            &'                           sec.      %                sec. ', &
+             &'     sec.      sec.'/  &
+            &'-----------------------------------------------------------', &
+             &'-------------------')
+
+101 FORMAT (/'special measures:'/ &
+            &'-----------------------------------------------------------', &
+            &'--------------------')
+
+102 FORMAT (A20,2X,F9.3,2X,F7.2,1X,I7,3(1X,F9.3))
+103 FORMAT (//)
+
+ END SUBROUTINE cpu_statistics
+
Index: palm/trunk/SOURCE/data_log.f90
===================================================================
--- palm/trunk/SOURCE/data_log.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_log.f90	(revision 1)
@@ -1,38 +1,12 @@
-!> @file data_log.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE data_log( array, i1, i2, j1, j2, k1, k2 )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-!
-! 3725 2019-02-07 10:11:02Z raasch
-! preprocessor directives removed to avoid compiler warnings
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! Corrected "Former revisions" section
-!
+! $Log: data_log.f90,v $
 ! Revision 1.1  2006/02/23 10:09:29  raasch
 ! Initial revision
@@ -41,25 +15,16 @@
 ! Description:
 ! ------------
-!> Complete logging of data
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE data_log( array, i1, i2, j1, j2, k1, k2 )
+! Complete logging of data
+!------------------------------------------------------------------------------!
+#if defined( __logging )
 
-    USE control_parameters,                                                                        &
-        ONLY:  log_message, simulated_time
-
-    USE kinds
-
+    USE control_parameters
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i1  !<
-    INTEGER(iwp) ::  i2  !<
-    INTEGER(iwp) ::  j1  !<
-    INTEGER(iwp) ::  j2  !<
-    INTEGER(iwp) ::  k1  !<
-    INTEGER(iwp) ::  k2  !<
+    INTEGER ::  i1, i2, j1, j2, k1, k2
 
-    REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2) ::  array  !<
+    REAL, DIMENSION(i1:i2,j1:j2,k1:k2) ::  array
 
 
@@ -80,31 +45,26 @@
     WRITE ( 20 )  array
 
+#endif
  END SUBROUTINE data_log
 
 
 
-!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE data_log_2d( array, i1, i2, j1, j2)
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Complete logging of data for 2d arrays
-!--------------------------------------------------------------------------------------------------!
+! Same as above, for 2d arrays
+!------------------------------------------------------------------------------!
+#if defined( __logging )
 
- SUBROUTINE data_log_2d( array, i1, i2, j1, j2)
-
-    USE control_parameters,                                                                        &
-        ONLY:  log_message, simulated_time
-
-    USE kinds
-
+    USE control_parameters
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i1  !<
-    INTEGER(iwp) ::  i2  !<
-    INTEGER(iwp) ::  j1  !<
-    INTEGER(iwp) ::  j2  !<
+    INTEGER ::  i1, i2, j1, j2
 
-    REAL(wp), DIMENSION(i1:i2,j1:j2) ::  array  !<
+    REAL, DIMENSION(i1:i2,j1:j2) ::  array
 
 
@@ -125,31 +85,26 @@
     WRITE ( 20 )  array
 
+#endif
  END SUBROUTINE data_log_2d
 
 
 
-!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE data_log_2d_int( array, i1, i2, j1, j2)
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Complete logging of data for 2d integer arrays
-!--------------------------------------------------------------------------------------------------!
+! Same as above, for 2d integer arrays
+!------------------------------------------------------------------------------!
+#if defined( __logging )
 
- SUBROUTINE data_log_2d_int( array, i1, i2, j1, j2)
-
-    USE control_parameters,                                                                        &
-        ONLY:  log_message, simulated_time
-
-    USE kinds
-
+    USE control_parameters
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i1  !<
-    INTEGER(iwp) ::  i2  !<
-    INTEGER(iwp) ::  j1  !<
-    INTEGER(iwp) ::  j2  !<
+    INTEGER ::  i1, i2, j1, j2
 
-    INTEGER(iwp), DIMENSION(i1:i2,j1:j2) ::  array  !<
+    INTEGER, DIMENSION(i1:i2,j1:j2) ::  array
 
 
@@ -170,3 +125,4 @@
     WRITE ( 20 )  array
 
+#endif
  END SUBROUTINE data_log_2d_int
